# -*- R -*-
# $RCSfile: connectionMethods.R,v $
# $Date: 2004-03-09 09:55:04 -0800 (Tue, 09 Mar 2004) $
# $Revision: 1.4 $
# Copyright 2001, Timothy H. Keitt
# Licence: GPL

#
# Methods to implement Rdbi interface
#

PgSQL <- function() {

  out <- list(description = "PostgreSQL object")

  class(out) <- c("PgSQL", "Rdbi")

  return(out)

}

dbConnect.PgSQL <- function(dbObj, ...) {

  conninfo <- list.to.key.pair.string(list(...))
  # list.to.key.pair.string defined in util.R in Rdbi

  conn <- .Call("PgSQLconnect", conninfo, PACKAGE="RdbiPgSQL")

  class(conn) <- c("PgSQL.conn", "Rdbi.conn")

  attr(conn, "library.call") <- expression(library(RdbiPgSQL))
  attr(conn, "connect.call") <- match.call()
  # allows connection to be recreated later

  conninfo <- dbConnectionInfo(conn)

  if (conninfo$status != 0)
    stop(conninfo$last.message)
  else
    dbSendQuery(conn, "SET DATESTYLE TO 'Postgres, US'")
    # Necessary to make dates() and times() work

  return(conn)

}
# Code modified by JZ. 10/8/2003
dbDisconnect.PgSQL.conn <- function(conn) {
  options(show.error.messages = FALSE)
  tryMe <- try(.Call("PgSQLcloseConnection", conn, PACKAGE="RdbiPgSQL"))
  options(show.error.messages = TRUE)

  if(inherits(tryMe, "try-error")){
      return(paste("Failed to disconnect DB connection because of", tryMe))
  }else{
      return(invisible())
  }
}

dbConnectionInfo.PgSQL.conn <- function(conn) {

  conninfo <- .Call("PgSQLconnectionInfo", conn, PACKAGE="RdbiPgSQL")

  conninfo <- lapply(conninfo, strip.line.feeds)

  return(conninfo)

}









